diff options
author | Bruno Haible <bruno@clisp.org> | 2004-01-06 10:22:43 +0000 |
---|---|---|
committer | Bruno Haible <bruno@clisp.org> | 2009-06-23 12:11:33 +0200 |
commit | 4e4dc77d259fe03361ae42b99c801d0485bca72f (patch) | |
tree | 824fe6e02fb64f2fa21e66cbc4e332ff2b349ef8 /gettext-tools/tests/format-csharp-2 | |
parent | 2ed89e80c6fccbc61bb6e045f98b84555ce1894b (diff) | |
download | external_gettext-4e4dc77d259fe03361ae42b99c801d0485bca72f.zip external_gettext-4e4dc77d259fe03361ae42b99c801d0485bca72f.tar.gz external_gettext-4e4dc77d259fe03361ae42b99c801d0485bca72f.tar.bz2 |
Tests for C# format string recognition.
Diffstat (limited to 'gettext-tools/tests/format-csharp-2')
-rwxr-xr-x | gettext-tools/tests/format-csharp-2 | 79 |
1 files changed, 79 insertions, 0 deletions
diff --git a/gettext-tools/tests/format-csharp-2 b/gettext-tools/tests/format-csharp-2 new file mode 100755 index 0000000..9180bc1 --- /dev/null +++ b/gettext-tools/tests/format-csharp-2 @@ -0,0 +1,79 @@ +#! /bin/sh + +# Test checking of Java format strings. + +tmpfiles="" +trap 'rm -fr $tmpfiles' 1 2 3 15 + +tmpfiles="$tmpfiles f-cs-2.data" +cat <<\EOF > f-cs-2.data +# Invalid: invalid msgstr +msgid "abc{0}def" +msgstr "abc{" +# Valid: same arguments +msgid "abc{1}def" +msgstr "xyz{1}" +# Valid: same arguments, differently written +msgid "abc{1}def" +msgstr "xyz{01}" +# Valid: permutation +msgid "abc{2}{0}{1}def" +msgstr "xyz{1}{0}{2}" +# Invalid: too few arguments +msgid "abc{1}def{0}" +msgstr "xyz{0}" +# Invalid: too many arguments +msgid "abc{0}def" +msgstr "xyz{0}uvw{1}" +# Valid: missing non-final argument +msgid "abc{1}def{0}" +msgstr "xyz{1}" +# Valid: added non-final argument +msgid "abc{1}def" +msgstr "xyz{0}{1}" +# Invalid: different number of arguments +msgid "abc{500000000}def" +msgstr "xyz{500000001}" +# Valid: type compatibility +msgid "abc{1:X}" +msgstr "xyz{1:g}" +EOF + +: ${MSGFMT=msgfmt} +n=0 +while read comment; do + read msgid_line + read msgstr_line + n=`expr $n + 1` + tmpfiles="$tmpfiles f-cs-2-$n.po f-cs-2-$n.mo" + cat <<EOF > f-cs-2-$n.po +#, csharp-format +${msgid_line} +${msgstr_line} +EOF + fail= + if echo "$comment" | grep 'Valid:' > /dev/null; then + if ${MSGFMT} --check-format -o f-cs-2-$n.mo f-cs-2-$n.po; then + : + else + fail=yes + fi + else + ${MSGFMT} --check-format -o f-cs-2-$n.mo f-cs-2-$n.po 2> /dev/null + if test $? = 1; then + : + else + fail=yes + fi + fi + if test -n "$fail"; then + echo "Format string checking error:" 1>&2 + cat f-cs-2-$n.po 1>&2 + exit 1 + fi + rm -f f-cs-2-$n.po f-cs-2-$n.mo +done < f-cs-2.data + +rm -fr $tmpfiles + +exit 0 |